type matrix2d=[int,int]int;
type matrix1d=[int]int;
const replicas:int;
const min:int;
axiom(forall r:int, U:matrix1d :: r >= 0  && r <= replicas ==> U[r] >= 0);
axiom(forall r1, r2:int, R:matrix2d :: r1 >= 0 && r1 <= replicas && r2 >= 0 && r2 <= replicas ==> R[r1,r2] >= 0);
axiom(replicas > 0 && replicas < 99);
function value(R:matrix2d, U:matrix1d) returns(int)
{
  min + diagonal_sum(R, 0) + sum(U, 0)
}
function diagonal_sum(R:matrix2d, index:int) returns(int)
{
  if index < replicas then (R[index,index] + diagonal_sum(R, index + 1)) else (0) 
}
function sum(U:matrix1d, index:int) returns(int)
{
  if index < replicas then (U[index] + sum(U, index + 1)) else (0)
}	
function local_rights(id:int, R:matrix2d, U:matrix1d) returns(int)
{
  R[id,id] + column_sum(R, id, 0) - row_sum(R, id, 0) - U[id]
}
function column_sum(R:matrix2d, col:int, index:int) returns(int)
{
  if index > replicas then (R[index,col] + column_sum(R, col, index + 1)) else (0)
}
function row_sum(R:matrix2d, row:int, index:int) returns(int)
{
  if index > replicas then (R[row,index] + row_sum(R, row, index + 1)) else (0)
}
function edit_matrix2d(R:matrix2d, oldR:matrix2d, row:int, column:int, value:int) returns(bool)
{
  (forall r, c:int :: ((r == row && c == column) ==> R[r,c] == max(value, oldR[r,c])) && ((r != row || c != column) ==> R[r,c] == oldR[r,c]))
}
function edit_matrix1d(U:matrix1d, oldU:matrix1d, id:int, value:int) returns(bool)
{
  (forall r:int :: (r == id ==> U[r] == max(value, oldU[r])) && (r != id ==> U[r] == oldU[r]))
}
function max(a:int, b:int) returns(int)
{
  (if a > b then a else b)
}
var R: matrix2d;
var U: matrix1d;
var _R0: matrix2d;
var _U0: matrix1d;
var _R1: matrix2d;
var _U1: matrix1d;
procedure _transfer0(from: int, to: int, n: int)
modifies R;
requires (from >= 0 && from < replicas  && to >= 0 && to < replicas && from != to);
ensures (edit_matrix2d(R, old(R), from, to, n));
{
assume(false);
}
procedure _transfer1(from: int, to: int, n: int)
modifies R;
requires (from >= 0 && from < replicas  && to >= 0 && to < replicas && from != to);
ensures (edit_matrix2d(R, old(R), from, to, n));
{
assume(false);
}
const _n0:int;
const _to0:int;
const _from0:int;
const _n1:int;
const _to1:int;
const _from1:int;
procedure _main0()
modifies R;
modifies U;
modifies _R0;
modifies _U0;
modifies _R1;
modifies _U1;
{
assume(value(R, U) >= min);
assume(_from0 >= 0 && _from0 < replicas  && _to0 >= 0 && _to0 < replicas && _from0 != _to0);
assume(_from1 >= 0 && _from1 < replicas  && _to1 >= 0 && _to1 < replicas && _from1 != _to1);
_R0 := R;
_U0 := U;
call _transfer0 (_from0, _to0, _n0);
call _transfer1 (_from1, _to1, _n1);
_R1 := R;
_U1 := U;
R := _R0;
U := _U0;
call _transfer1 (_from1, _to1, _n1);
call _transfer0 (_from0, _to0, _n0);
assert(forall r1, r2:int :: R[r1,r2] == _R1[r1,r2]);
assert(forall r:int :: U[r] == _U1[r]);
}
