type matrix2d=[int,int]int;
type matrix1d=[int]int;
const replicas:int;
const min:int;
axiom(forall r:int, U:matrix1d :: r >= 0  && r <= replicas ==> U[r] >= 0);
axiom(forall r1, r2:int, R:matrix2d :: r1 >= 0 && r1 <= replicas && r2 >= 0 && r2 <= replicas ==> R[r1,r2] >= 0);
axiom(replicas > 0 && replicas < 99);
function value(R:matrix2d, U:matrix1d) returns(int)
{
  min + diagonal_sum(R, 0) + sum(U, 0)
}
function diagonal_sum(R:matrix2d, index:int) returns(int)
{
  if index < replicas then (R[index,index] + diagonal_sum(R, index + 1)) else (0) 
}
function sum(U:matrix1d, index:int) returns(int)
{
  if index < replicas then (U[index] + sum(U, index + 1)) else (0)
}	
function local_rights(id:int, R:matrix2d, U:matrix1d) returns(int)
{
  R[id,id] + column_sum(R, id, 0) - row_sum(R, id, 0) - U[id]
}
function column_sum(R:matrix2d, col:int, index:int) returns(int)
{
  if index > replicas then (R[index,col] + column_sum(R, col, index + 1)) else (0)
}
function row_sum(R:matrix2d, row:int, index:int) returns(int)
{
  if index > replicas then (R[row,index] + row_sum(R, row, index + 1)) else (0)
}
function edit_matrix2d(R:matrix2d, oldR:matrix2d, row:int, column:int, value:int) returns(bool)
{
  (forall r, c:int :: ((r == row && c == column) ==> R[r,c] == max(value, oldR[r,c])) && ((r != row || c != column) ==> R[r,c] == oldR[r,c]))
}
function edit_matrix1d(U:matrix1d, oldU:matrix1d, id:int, value:int) returns(bool)
{
  (forall r:int :: (r == id ==> U[r] == max(value, oldU[r])) && (r != id ==> U[r] == oldU[r]))
}
function max(a:int, b:int) returns(int)
{
  (if a > b then a else b)
}
var R: matrix2d;
var U: matrix1d;
procedure _increment0(id: int, n: int)
modifies R;
requires (id >= 0 && id < replicas);
ensures (edit_matrix2d(R, old(R), id, id, n));
{
assume(false);
}
procedure _increment1(id: int, n: int)
modifies R;
requires (id >= 0 && id < replicas);
ensures (edit_matrix2d(R, old(R), id, id, n));
{
assume(false);
}
const _id0:int;
const _n0:int;
const _id1:int;
const _n1:int;
procedure _main0()
modifies R;
modifies R;
{
assume(value(R, U) >= min);
assume(_id0 >= 0 && _id0 < replicas);
assume(_id1 >= 0 && _id1 < replicas);
call _increment0 (_id0, _n0);
call _increment1 (_id1, _n1);
}
procedure _main1()
modifies R;
modifies R;
{
assume(value(R, U) >= min);
assume(_id0 >= 0 && _id0 < replicas);
assume(_id1 >= 0 && _id1 < replicas);
call _increment1 (_id1, _n1);
call _increment0 (_id0, _n0);
}
