type Credit = int;
type ReplicaID;
var localCredit: [ReplicaID]Credit;
var globalCredit: Credit;
procedure increment(replica: ReplicaID, k: Credit)
modifies localCredit;
requires (k > 0);
ensures (forall r:ReplicaID :: (r == replica ==> localCredit[r] == old(localCredit)[r] + k) && (r != replica ==> localCredit[r] == old(localCredit)[r]));
{
assume(false);
}
procedure decrement(replica: ReplicaID, k: Credit)
modifies localCredit;
requires (k > 0 && localCredit[replica] >= k);
ensures (forall r:ReplicaID :: (r == replica ==> localCredit[r] == old(localCredit)[r] - k) && (r != replica ==> localCredit[r] == old(localCredit)[r]));
{
assume(false);
}
const _k0:Credit;
const _replica0:ReplicaID;
const _replica1:ReplicaID;
const _k1:Credit;
procedure _main0()
modifies localCredit;
modifies localCredit;
{
assume(_replica0 != _replica1);
assume((forall r:ReplicaID :: localCredit[r] >= 0) && (globalCredit >= 0));
assume(_k0 > 0);
assume(_k1 > 0 && localCredit[_replica1] >= _k1);
call increment (_replica0, _k0);
call decrement (_replica1, _k1);
}
procedure _main1()
modifies localCredit;
modifies localCredit;
{
assume(_replica0 != _replica1);
assume((forall r:ReplicaID :: localCredit[r] >= 0) && (globalCredit >= 0));
assume(_k0 > 0);
assume(_k1 > 0 && localCredit[_replica1] >= _k1);
call decrement (_replica1, _k1);
call increment (_replica0, _k0);
}
