type Credit = int;
type ReplicaID;
var localCredit: [ReplicaID]Credit;
var globalCredit: Credit;
procedure _acquireCredit0(replica: ReplicaID, k: Credit)
modifies globalCredit;
modifies localCredit;
requires (k > 0 && globalCredit >= k);
ensures ((forall r:ReplicaID :: (r == replica ==> localCredit[r] == old(localCredit)[r] + k) && (r != replica ==> localCredit[r] == old(localCredit)[r])) && globalCredit == old(globalCredit) - k);
{
assume(false);
}
procedure _acquireCredit1(replica: ReplicaID, k: Credit)
modifies globalCredit;
modifies localCredit;
requires (k > 0 && globalCredit >= k);
ensures ((forall r:ReplicaID :: (r == replica ==> localCredit[r] == old(localCredit)[r] + k) && (r != replica ==> localCredit[r] == old(localCredit)[r])) && globalCredit == old(globalCredit) - k);
{
assume(false);
}
const _k0:Credit;
const _replica0:ReplicaID;
const _k1:Credit;
const _replica1:ReplicaID;
procedure _main0()
modifies globalCredit;
modifies localCredit;
modifies globalCredit;
modifies localCredit;
{
assume((forall r:ReplicaID :: localCredit[r] >= 0) && (globalCredit >= 0));
assume(_k0 > 0 && globalCredit >= _k0);
assume(_k1 > 0 && globalCredit >= _k1);
call _acquireCredit0 (_replica0, _k0);
call _acquireCredit1 (_replica1, _k1);
}
procedure _main1()
modifies globalCredit;
modifies localCredit;
modifies globalCredit;
modifies localCredit;
{
assume((forall r:ReplicaID :: localCredit[r] >= 0) && (globalCredit >= 0));
assume(_k0 > 0 && globalCredit >= _k0);
assume(_k1 > 0 && globalCredit >= _k1);
call _acquireCredit1 (_replica1, _k1);
call _acquireCredit0 (_replica0, _k0);
}
