type Object;
type Ref;
type Field a;
type ListType = [Ref]<a>[Field a] a;
type Flag = [Ref]bool;
const unique content:Field Object;
const unique next:Field Ref;
const unique clock_ins:Field int;
const unique clock_up:Field int;
const tombstone:Object;
const head:Ref;
const tail:Ref;
function create_node(obj:Object, time:int) returns (result:Ref);
function get_actual_reference(list:ListType, base:Ref, time:int) returns (result:Ref)
{
  if (list[list[base][next]][clock_ins] < time) then (base) else (get_actual_reference(list, list[base][next], time))
}
function is_successor(list:ListType, base:Ref, successor:Ref) returns (result:bool)
{
  list[base][next] == successor || is_successor(list, list[base][next], successor)
}
axiom (forall list:ListType, presence:Flag, r:Ref :: presence[r] == presence[list[r][next]]);
axiom (forall list:ListType, presence:Flag :: list[tail][content] == tombstone && list[tail][clock_ins] == 0 && list[tail][clock_up] == 0 && list[tail][next] == tail && presence[tail] == true);
axiom (forall list:ListType, presence:Flag :: list[head][content] == tombstone && list[head][clock_ins] == 0 && list[head][clock_up] == 0 && presence[head] == true);
axiom (forall list:ListType, presence:Flag, r:Ref :: r!= tail && r != head && presence[r] == true ==> list[r][clock_ins] > 0 && list[r][clock_up] > 0);
axiom (forall list:ListType, r1, r2:Ref :: r1 != head && r2 != head && r1 != tail && r2 != tail && r1 != r2 ==> list[r1][clock_up] != list[r2][clock_up] && list[r1][clock_ins] != list[r2][clock_ins]);
axiom (forall obj1, obj2:Object, time1, time2:int :: (obj1 != obj2 || time1 != time2 ==> create_node(obj1, time1) != create_node(obj2, time2)) && (obj1 == obj2 && time1 == time2 ==> create_node(obj1, time1) == create_node(obj2, time2)));
axiom (forall obj:Object, time:int :: create_node(obj, time) != head && create_node(obj, time) != tail);
axiom (forall list:ListType, presence:Flag, r1, r2:Ref :: r1!= tail && r2 != tail && r1 != r2 && presence[r1] == true && presence[r2] == true ==> list[r1][next] != list[r2][next]);
axiom (forall list:ListType, presence:Flag, r:Ref :: presence[r] == true ==> is_successor(list, r, tail));
axiom (forall list:ListType, presence:Flag, r:Ref :: presence[r] == true ==> is_successor(list, head, r));
var list: ListType;
var presence: Flag;
var _list0: ListType;
var _presence0: Flag;
var _list1: ListType;
var _presence1: Flag;
procedure delete(base: Ref, time: int)
modifies list;
requires ((base != tail) && (presence[base] == true));
ensures ((forall r:Ref :: (r == base && old(list)[base][clock_up] < time ==> list[r][content] == tombstone && list[r][clock_up] == time) && (r != base || old(list)[base][clock_up] >= time ==> list[r][content] == old(list)[r][content] && list        [r][clock_up] == old(list)[r][clock_up]) && list[r][next] == old(list)[r][next] && list[r][clock_ins] == old(list)[r][clock_ins]));
{
assume(false);
}
procedure update(base: Ref, obj: Object, time: int)
modifies list;
requires ((base != tail) && (presence[base] == true));
ensures ((forall r:Ref :: (r == base && old(list)[r][clock_up] < time ==> list[r][content] == obj && list[r][clock_up] == time) && (r != base || old(list)[r][clock_up] >= time ==> list[r][content] == old(list)[r][content] && list[r][clock_up        ] == old(list)[r][clock_up]) && list[r][next] == old(list)[r][next] && list[r][clock_ins] == old(list)[r][clock_ins]));
{
assume(false);
}
const _time0:int;
const _base0:Ref;
const _time1:int;
const _base1:Ref;
const _obj0:Object;
procedure _main0()
modifies list;
modifies presence;
modifies _list0;
modifies _presence0;
modifies _list1;
modifies _presence1;
{
assume((exists r:Ref :: presence[r] == true && list[head][next] == r) && (exists r:Ref :: presence[r] == true && list[r][next] == tail));
assume((_base0 != tail) && (presence[_base0] == true));
assume((_base1 != tail) && (presence[_base1] == true));
_list0 := list;
_presence0 := presence;
call delete (_base0, _time0);
call update (_base1, _obj0, _time1);
_list1 := list;
_presence1 := presence;
list := _list0;
presence := _presence0;
call update (_base1, _obj0, _time1);
call delete (_base0, _time0);
assert(forall r:Ref :: list[r][clock_ins] == _list1[r][clock_ins] && list[r][clock_up] == _list1[r][clock_up] && list[r][content] == _list1[r][content] && list[r][next] == _list1[r][next]);
assert(forall r:Ref :: presence[r] == _presence1[r]);
}
