type Object;
type Ref;
type Field a;
type ListType = [Ref]<a>[Field a] a;
type Flag = [Ref]bool;
const unique content:Field Object;
const unique next:Field Ref;
const unique clock_ins:Field int;
const unique clock_up:Field int;
const tombstone:Object;
const head:Ref;
const tail:Ref;
function create_node(obj:Object, time:int) returns (result:Ref);
function get_actual_reference(list:ListType, base:Ref, time:int) returns (result:Ref)
{
  if (list[list[base][next]][clock_ins] < time) then (base) else (get_actual_reference(list, list[base][next], time))
}
function is_successor(list:ListType, base:Ref, successor:Ref) returns (result:bool)
{
  list[base][next] == successor || is_successor(list, list[base][next], successor)
}
axiom (forall list:ListType, presence:Flag, r:Ref :: presence[r] == presence[list[r][next]]);
axiom (forall list:ListType, presence:Flag :: list[tail][content] == tombstone && list[tail][clock_ins] == 0 && list[tail][clock_up] == 0 && list[tail][next] == tail && presence[tail] == true);
axiom (forall list:ListType, presence:Flag :: list[head][content] == tombstone && list[head][clock_ins] == 0 && list[head][clock_up] == 0 && presence[head] == true);
axiom (forall list:ListType, presence:Flag, r:Ref :: r!= tail && r != head && presence[r] == true ==> list[r][clock_ins] > 0 && list[r][clock_up] > 0);
axiom (forall list:ListType, r1, r2:Ref :: r1 != head && r2 != head && r1 != tail && r2 != tail && r1 != r2 ==> list[r1][clock_up] != list[r2][clock_up] && list[r1][clock_ins] != list[r2][clock_ins]);
axiom (forall obj1, obj2:Object, time1, time2:int :: (obj1 != obj2 || time1 != time2 ==> create_node(obj1, time1) != create_node(obj2, time2)) && (obj1 == obj2 && time1 == time2 ==> create_node(obj1, time1) == create_node(obj2, time2)));
axiom (forall obj:Object, time:int :: create_node(obj, time) != head && create_node(obj, time) != tail);
axiom (forall list:ListType, presence:Flag, r1, r2:Ref :: r1!= tail && r2 != tail && r1 != r2 && presence[r1] == true && presence[r2] == true ==> list[r1][next] != list[r2][next]);
axiom (forall list:ListType, presence:Flag, r:Ref :: presence[r] == true ==> is_successor(list, r, tail));
axiom (forall list:ListType, presence:Flag, r:Ref :: presence[r] == true ==> is_successor(list, head, r));
var list: ListType;
var presence: Flag;
const _base0:Ref;
const _base1:Ref;
procedure _main0()
{
assume((exists r:Ref :: presence[r] == true && list[head][next] == r) && (exists r:Ref :: presence[r] == true && list[r][next] == tail));
assume((_base0 != tail) && (presence[_base0] == true));
assume((_base1 != tail) && (presence[_base1] == true));
assert(false);
}
