@import;

@init
type ReplicaID;
const min:int;

@variables
var counter:int;
var lock:ReplicaID;

@invariant
counter >= min;

@operations
procedure increment(replica:ReplicaID, value:int)
modifies counter;
requires value > 0;
ensures counter == old(counter) + value;

procedure decrement(replica:ReplicaID, value:int)
modifies counter;
requires value > 0 && (counter >= value + min) && lock == replica;
ensures counter == old(counter) - value;
